import java.awt.Color;
import java.awt.Point;

import org.junit.Assert;
import org.junit.Test;

/**
 * Test cases for the Oval and the Circle
 * 
 * @author Monique Shotande, Modified by ***
 * @version October 26, 2017
 * Lab 10
 */
public class OvalTest
{
    private Oval o1 = new Oval(new Point(100, 100), 50, 100, Color.BLACK, true);
    private Oval o2 = new Oval(new Point(100, 100), 75, 50, Color.CYAN, false);

    private Circle c1 = new Circle(new Point(200, 300), 60, Color.BLUE, true);
    private Circle c2 = new Circle(new Point(200, 300), 75, Color.RED, false);

    /**
     * Verify the affects of the constructor for the Oval and Circle
     * The location, the diameter(s), the color, and the filled flag
     */
    @Test
    public void testOvalConstructorPoint()
    {
        // Verify the quantity of points for each shape
        Assert.assertEquals("Quantity of points defining the Oval is more than 1", 1, o1.getLocation().length);
        Assert.assertEquals("Quantity of points defining the Circle is more than 1", 1, c1.getLocation().length);

        // Verify the location for each shape
        Assert.assertEquals("Incorrect location for the Oval", new Point(100, 100), o1.getLocation()[0]);
        Assert.assertEquals("Incorrect location for the Circle", new Point(200, 300), c1.getLocation()[0]);

        // Verify the colors for each shape
        Assert.assertEquals("Incorrect color for the Oval", Color.BLACK, o1.getColor());
        Assert.assertEquals("Incorrect color for the Circle", Color.BLUE, c1.getColor());

        // Verify the diameter(s) are correctly set
        Assert.assertEquals("Incorrect diameter1 for the Oval", 50, o1.getDiameter1());        
        Assert.assertEquals("Incorrect diameter1 for the Circle", 60, c1.getDiameter1());

        // TODO: finish this test method
    }
}
