import java.awt.Color;
import java.awt.Point;

import org.junit.Assert;
import org.junit.Test;

/**
 * Test cases for the Square
 * 
 * @author CS2334
 * @version October 26, 2017
 * Lab 10
 */
public class SquareTest
{
    private static Square s1 = new Square(new Point(100, 100), 100, Color.BLACK, true);
    private static Point s1UL = new Point(100, 100);
    private static Point s1LL = new Point(100, 200);
    private static Point s1UR = new Point(200, 100);
    private static Point s1LR = new Point(200, 200);
    private static Square s2 = new Square(new Point(100, 100), 75, Color.CYAN, false);
    private static Point s2UL = new Point(100, 100);
    private static Point s2LL = new Point(100, 175);
    private static Point s2UR = new Point(175, 100);
    private static Point s2LR = new Point(175, 175);

    /**
     * Right number of points?
     */
    @Test
    public void testSquareConstructorPointsArrayLength()
    {
        Point[] pts = s1.getLocation();
        Assert.assertEquals(4, pts.length);
    }
    
    /**
     * Check points
     */
    @Test
    public void testSquareConstructorCalculatedPoints()
    {
        Point[] pts1 = s1.getLocation();
        /*
        Assert.assertEquals(s1UL, pts1[0]);
        Assert.assertEquals(s1LL, pts1[1]);
        Assert.assertEquals(s1LR, pts1[2]);
        Assert.assertEquals(s1UR, pts1[3]);
        */
        Assert.assertTrue(ShapeUtils.pointInSet(pts1, s1UL));
        Assert.assertTrue(ShapeUtils.pointInSet(pts1, s1LL));
        Assert.assertTrue(ShapeUtils.pointInSet(pts1, s1LR));
        Assert.assertTrue(ShapeUtils.pointInSet(pts1, s1UR));
        
        Point[] pts2 = s2.getLocation();
        /*
        Assert.assertEquals(s2UL, pts2[0]);
        Assert.assertEquals(s2LL, pts2[1]);
        Assert.assertEquals(s2LR, pts2[2]);
        Assert.assertEquals(s2UR, pts2[3]);
        */
        Assert.assertTrue(ShapeUtils.pointInSet(pts2, s2UL));
        Assert.assertTrue(ShapeUtils.pointInSet(pts2, s2LL));
        Assert.assertTrue(ShapeUtils.pointInSet(pts2, s2LR));
        Assert.assertTrue(ShapeUtils.pointInSet(pts2, s2UR));
        
    }
    
    /**
     * Unfilled case
     */
    @Test
    public void testSquareConstructorUnfilled()
    {
        Assert.assertFalse(s2.isFilled());
    }
    
    /**
     * Filled case
     */
    @Test
    public void testSquareConstructorFilled()
    {
        Assert.assertTrue(s1.isFilled());
    }
    
    /**
     * Color
     */
    @Test
    public void testSquareConstructorColor()
    {
        Color clr1 = s1.getColor();
        Color clr2 = s2.getColor();
        Assert.assertEquals(Color.BLACK, clr1);
        Assert.assertEquals(Color.CYAN, clr2);
    }
}
