
import java.awt.Color;
import java.awt.Point;

import org.junit.Assert;
import org.junit.Test;

/**
 * Test cases for the Triangle
 * 
 * @author CS2334
 * @version October 26, 2017
 * Lab 10
 */
public class TriangleTest
{
    private static Triangle t1 = new Triangle(new Point(100, 100), 50, 100, Color.BLACK, true);
    private static Triangle t2 = new Triangle(new Point(100, 100), 75, -75, Color.BLUE, false);

    /**
     * Construct the triangles
     */
    @Test
    public void testTriangleConstuctorCalculatedPoints()
    {
        /*
        Point t1b1 = t1.getLocation()[0];
        Point t1b2 = t1.getLocation()[1];
        Point t1a = t1.getLocation()[2];
        Point t2b1 = t2.getLocation()[0];
        Point t2b2 = t2.getLocation()[1];
        Point t2a = t2.getLocation()[2];
        */
        
        Point[] t1Points = t1.getLocation();
        Point[] t2Points = t2.getLocation();
        /*
        Assert.assertEquals(new Point(100, 100), t1b1);
        Assert.assertEquals(new Point(150, 100), t1b2);
        Assert.assertEquals(new Point(125, 200), t1a);
        Assert.assertEquals(new Point(100, 100), t2b1);
        Assert.assertEquals(new Point(175, 100), t2b2);
        Assert.assertEquals(new Point(137, 25), t2a);
        */
        Assert.assertTrue(ShapeUtils.pointInSet(t1Points, new Point(100, 100)));
        Assert.assertTrue(ShapeUtils.pointInSet(t1Points, new Point(150, 100)));
        Assert.assertTrue(ShapeUtils.pointInSet(t1Points, new Point(125, 200), 1)
                || ShapeUtils.pointInSet(t1Points, new Point(125, 0), 1));
        Assert.assertTrue(ShapeUtils.pointInSet(t2Points, new Point(100, 100)));
        Assert.assertTrue(ShapeUtils.pointInSet(t2Points, new Point(175, 100)));
        Assert.assertTrue(ShapeUtils.pointInSet(t2Points, new Point(137, 25), 1)
                || ShapeUtils.pointInSet(t2Points, new Point(137, 175), 1));
        
        
    }
    
    /**
     * Check number of points
     */
    @Test
    public void testTriangleConstructorPointsArraySize()
    {
        Point[] pts = t1.getLocation();
        Assert.assertEquals(3, pts.length);
    }
    
    /**
     * Color
     */
    @Test
    public void testTriangleConstructorColor()
    {
        Color clr1 = t1.getColor();
        Color clr2 = t2.getColor();
        Assert.assertEquals(Color.BLACK, clr1);
        Assert.assertEquals(Color.BLUE, clr2);
    }
    
    /**
     * Unfilled
     */
    @Test
    public void testTriangleConstructorUnfilled()
    {
        Assert.assertFalse(t2.isFilled());
    }
    
    /**
     * Filled
     */
    @Test
    public void testTriangleConstructorFilled()
    {
        Assert.assertTrue(t1.isFilled());
    }
}
